#include <sys/cdefs.h>
#include <sys/types.h>
#include <machine/types.h>
#include <vm/vm.h>
#include <vm/vm_kern.h>
#include <machine/psl.h>

#define USE_LITTLE_ENDIAN 1

#define high_priority() splhigh()
#define reset_priority(x) spl0()

#define TPROC (curproc)

#ifdef PROCESS
#define TIME gettimeofday
#define new_page(size) ((unsigned char *)sbrk(size))
#define GETSERVICE(x) getservbyname(x,0)
#endif

#ifdef KERNEL
#define TIME(x,y) microtime(x)
#define new_page(x) ((void *)kmem_alloc(kernel_map,x))
#endif
typedef struct selinfo select_state;
#define ANSI_CPP 1
