#include <elib/handler.h>
#include <elib/list.h>


void execute_handlers(list *h, void *arg)
{
  handler k;
  list *i,*next,temp;
  for (i=h;*i;i=next){
    next=&((*i)->rest);
    k=(handler)((*i)->first);
    if (!(*k->function)(arg,k->argument)){
      temp=*i;
      *i=(*i)->rest;
      deallocate_memory(temp);
      next=i;
    }
  }
}


void add_handler(list *h, int (*function)(), void *arg)
{
  handler new=(handler)allocate_memory(sizeof(struct handler));
  new->function=function;
  new->argument=arg;
  *h=insert(new,*h);
}

void remove_handler(list *h,int (*function)())
{
  handler k;
  list *i,*next,temp;

  for (i=h;*i;i=next){
    next=&((*i)->rest);
    k=(handler)((*i)->first);
    if (k->function==function){
      temp=*i;
      *i=(*i)->rest;
      deallocate_memory(temp);
      next=i;
      return;
    }
  }
}
