
#ifdef USE_LITTLE_ENDIAN

static unsigned int byte_mask[4]={0x000000ff,0x0000ff00,0x00ff0000,0xff000000};
static unsigned int byte_shift[4]={0,8,16,24};
#define vntohl(x) \
   ((((x)>>24)&0xff)|(((x)>>8)&0x0000ff00)|(((x)<<8)&0x00ff0000)|((x)<<24))
#define vntohs(x) (((x)>>8)|((x)<<8))

#else

static unsigned int byte_mask[4]={0xff000000,0x00ff0000,0x0000ff00,0x000000ff};
static unsigned int byte_shift[4]={24,16,8,0};
#define vntohl(x) (x)
#define vntohs(x) (x)

#endif

#define vhtonl(x) vntohl(x)
#define vhtons(x) vntohs(x)

#ifndef PUT_BYTE
#define PUT_BYTE(a,i,v) (a)[(i)]=(v)
#endif

#ifndef TIME 
#define TIME(x,y) 1
#endif
