#include <elib/list.h>

void add_property (list *pl, char *name, void *value)
{
  list *i;
  for (i=pl;*i;i=&((*i)->rest))
    if (string_equal(((list)((*i)->first))->first,name)){
      ((list)((*i)->first))->rest=value;
      return;
    }
  *pl=insert(insert(name,value),*pl);
}

void *find_property (list pl, char *name)
{
  list i;

  dolist(i,pl)
    if (string_equal(((list)(i->first))->first,name))
      return(((list)(i->first))->rest);
  return(0);
}


void delete_property (list *pl, char *name, void (*destroy)())
{
  list *i,temp;

  for (i=pl;*i;i=&((*i)->rest)){
    if (string_equal(((list)((*i)->first))->first,name)){
      temp=*i;
      if (destroy) (*destroy)(((list)((*i)->first))->rest);
      *i=(*i)->rest;
      deallocate_memory(temp);
      return;
    }
  }
}


