#include <stdio.h>
#include <elib/timer.h>
#include <elib/machine.h>
#include <sys/time.h>

int printer(arg)
     void *arg;
{
  printf ("%s\n",arg);
  return(1);
}


char one[]="one";
char five[]="five";
char ten[]="ten";
char sixty[]="sixty";

int standard[]={0,1};

void this(fds)
     int fds[2];
{
  char foo;
  if (read(fds[0],&foo,1)!=1){
    fprintf (stderr,"read failed.\n");
    exit(1);
  }
  write(fds[1],&foo,1);
}

static int block(int interval)
{
  usleep(interval*1000);
}

struct timeval beginning_of_epoch;

unsigned int now()
{
  struct timeval result;
  unsigned int delta;
  
  TIME(&result,0);
  delta=1000*(result.tv_sec-beginning_of_epoch.tv_sec)+
    ((result.tv_usec-beginning_of_epoch.tv_usec)/1000);
  return (delta);
}

main()
{
  TIME(&beginning_of_epoch,0);
  initialize_timer(block,now);
  register_timer(1000,printer,one);
  register_timer(5000,printer,five);
/*  remove_timer(register_timer(10000,printer,ten));*/
  register_timer(10000,printer,ten);
  register_timer(60000,printer,sixty);
  timer_loop(1,0);
}
