#include <protocol/protocol.h>

typedef struct layer_description {
  layer (*creation_function)();
  char *name;
  char *arguments;
  int (*identify)();
  int (*attach)();
  int (*detach)();
  void (*initialize)();
} *layer_description;

extern struct layer_description ltab[];
