#include <elib/table.h>
#include <protocol/protocol.h>

typedef struct enet_handler{
  layer l;
  unsigned short ethertype;
} *enet_handler;

typedef struct enet {
  layer l;
  table handlers;
} *enet;

static int handler_compare(enet_handler a,unsigned short k)
{
  return(a->ethertype==k);
}

static void allocate_down(layer l,int size)
{
  enet_handler e=(enet_handler)l->state;
}

static void from_below(layer l,pbuffer b,int f)
{
  enet e=(enet)l->state;
  enet_handler en;
  pbuffer temp;

  if (b){
    if (en=(enet_handler)table_find(e->handlers,buffer_read_short(b,12))){
      write_up(en->l,temp=allocate_fragment(b,14,buffer_length(b)-14),f);
      dereference_buffer(temp);
    }
  }
}

static void from_above(layer l,pbuffer b,int f)
{
  enet_handler e=(enet_handler)l->state;

}

layer create_enet_handler(layer l,unsigned short ethertype)
{
  enet e=(enet)l->state;
  enet_handler eh=(enet_handler)allocate_memory(sizeof(struct enet_handler));
  eh->ethertype=ethertype;
  table_insert(e->handlers,eh,eh->ethertype);
  return(eh->l=create_layer(e,from_above,0,allocate_down));
}

layer create_enet()
{
  enet e=(enet)allocate_memory(sizeof(struct enet));
  e->handlers=create_table(handler_compare,key_from_int);
  return(e->l=create_layer(e,0,from_below,0));
}
