#include <anemone.h>
#include <x.h>

void draw_x_chart(space sp,chart c)
{
  xspace s=(xspace)sp->hardware_local;
  int i,j;
  XCharStruct overall;
  int line_dec_state=1;
  int line_inc_state=0;
  int line_10_inc_state=0;
  int line_10_dec_state=1;
  char l[255];
  XTextItem my_item;
  int factor,place;
  int direction,ascent,descent;

  XFillRectangle (s->d,s->p,s->clear_gc,0,0,c->width,c->height);
  for (i=0,j=(c->sample_counter/*+1*/)%c->width;
       i<c->width;
       j=(j+1)%(c->width),i++){
    if (c->lines > 10) factor=c->lines+(10-c->lines%10);
    else factor=c->lines;
    if (factor < 1) factor==1.0;
    place=c->height-(int)(c->height*(c->state)[j])/factor;
    if (place > 0)
      XDrawLine (s->d,s->p,s->node_gc,i,c->height,i,place);
    if ((c->state)[j] > c->lines-1) line_dec_state=0;
    if ((c->state)[j] > c->lines-10) line_10_dec_state=0;
    if ((c->state)[j] > c->lines) line_inc_state=1;
    if ((c->state)[j] > c->lines+10) line_10_inc_state=1;
  }
  if (c->lines < 11){
    for (i=1;i<c->lines;i++){
      XDrawLine (s->d,s->p,s->xor_gc,
		 0,i*c->height/c->lines,c->width,i*c->height/c->lines);
    }
  } else {
    for (i=1;i<((c->lines+10)/10);i++){
      factor=i*c->height/((c->lines+10)/10);
      XDrawLine (s->d,s->p,s->thick_xor_gc,0,factor,c->width,factor);
    }
  }
  if (line_10_dec_state && c->lines > 1) 
    c->lines-=10;
  else 
    if (line_dec_state && c->lines > 1) c->lines--;
  
  if (line_10_inc_state)
    c->lines+=10;
  else 
    if (line_inc_state && c->lines) 
      c->lines++;
  sprintf (l,"%.1f",c->state[((c->sample_counter-1)+c->width)%c->width]);
  XTextExtents (s->f,l,strlen(l), &direction,&ascent,&descent,&overall);
  XFillRectangle (s->d,s->p,s->clear_gc,
		  0,c->height-5-overall.ascent,
		  (overall.lbearing+overall.rbearing)+5,c->height);
  XDrawString (s->d,s->p,s->xor_gc,2,c->height-3,l,string_length(l));
}


