#include <anemone.h>
#include <x.h>
#include <elib/string.h>

void redraw_panel(panel pa)
{
  /*  panel_element i;
  int x,y;
  for(x=0;){
    for(i){

  }*/
}

void add_object_to_panel(panel pa,
			 void *context,
			 void (*press)(),
			 void (*release)(),
			 void (*character)())
{
  panel_element p=(panel_element)allocate_memory(sizeof(struct panel_element));
  
}

void draw_buttons(panel p)
{
  int y=0;
  list i;
  button b;

  dolist (i,p->buttons){
    b=(button)i->first;
    draw_x_button(p,b,1,y,p->width,p->button_height);
    y+=p->button_height;
  }
}

void x_resize_panel(panel p)
{
  if (p->p) XFreePixmap(p->s->d,p->p);
  p->p=XCreatePixmap (p->s->d,p->s->w,p->width,
		      p->height,p->s->depth);
  XFillRectangle(p->s->d,p->p,p->s->panel_clear_gc,0,0,
		 p->width,p->height);
  draw_buttons(p);
}


panel create_panel(xspace s,panel parent,
		   int width,int height,int button_height)
{
  panel p=(panel)allocate_memory(sizeof(struct panel));
  p->pa=parent;
  p->buttons=0;
  p->width=width;
  p->height=height;
  p->button_height=button_height;
  p->s=s;
  p->p=0;
  return(p);
}
