
void resize_chart(chart c,int width,int height)
{
  float *new;
  int i,j;
  if ((c->width != width) || (c->height != height)){
    new=(float *)malloc(sizeof(float)*width);
    for (i=0,j=(c->sample_counter+1)%c->width;
	 i<((width>c->width)?c->width:width);
	 j=(j+1)%(c->width),i++){
      new[i]=c->state[j];
    }
    for (i=MIN(width,c->width);i<width;i++) new[i]=0;
    c->sample_counter=c->width-1;
    c->width=width;
    c->height=height;
    free(c->state);  
    c->state=new;
  }
}


void add_sample (chart c,float value)
{
  c->state[c->sample_counter]=value;
  c->sample_counter=(c->sample_counter+1)%c->width;
}

chart create_chart(space sp,int width,int height)
{
  chart c=(chart)malloc(sizeof(struct chart));
  int j;  

  c->lines=1;
  c->sample_counter=0;
  c->state=(float *)malloc(sizeof(float)*width);
  for (j=0;j<width;j++) c->state[j]=0.0;
  return(c);
}
