#include <rmap.h>

unsigned my_map[8192]={0};

void print_rmap(list r)
{
  if (!r){
    printf ("\n");
  } else {
    printf ("[%d %d] ",r->first,r->rest->first);
    print_rmap(r->rest->rest);
  }
}

main()
{
  rmap r=create_rmap(1,8191);
  int i;
  int size;
  int base;

  while (1){
    size=random()%512;
    if (base=rmap_allocate_arbitrary(r,size)){
      printf ("allocated %d to %d\n",base,base+size);
      print_rmap(*r);
      for (i=base;i<base+size;i++){
	if (my_map[i]) printf ("failure\n");
	my_map[i]=1;
      }
    }
    for (i=0;i<size;){
      base=random()%8192;
      if (my_map[base]){
	my_map[base]=0;
	rmap_deallocate(r,base,base+1);
	printf ("deallocated %d\n",base);
	print_rmap(*r);
	i++;
      }
    }
    sleep(1);
  }
}
