#include <anemone.h>

void group_nodes(space s,char *name,list i)
{
  list k;
  node n=create_node(s,name),z;
  int x;

  dolist(k,i){
      z=(node)k->first;
      remove_instrument(z->i);
      if (z->child_last) 
	  if (*z->child_last=z->child_next) 
	      z->child_next->child_last=z->child_last;
      if (z->child_next=n->children) z->child_next->child_last=&z->child_next;
      z->child_last=&n->children;
      z->parent=n;
      n->children=z;
  }
  for (x=0,z=n->children;z;z=z->child_next,x++) z->child_index=x;
}

static int coalesce_check(node n)
{
  node parent=0;
  if (n->parent || (n->froms && n->tos)) return(1);
  if (n->froms) {
    if (n->froms->from_next) return(1);
    parent=(node)n->froms->to;
  }
  if (n->tos) {
    if (n->tos->to_next) return(1);
    parent=(node)n->tos->from;
  }
  undisplay_node(n);
  n->parent=parent;
  parent->children=(list)insert(n,parent->children);
  return(1);
}

void coalesce(space s)
{
  iterate_table_entries(s->nodes,coalesce_check,0);
}

void ungroup_node(node n)
{
  list k;
  node j;
  dolist(k,(list)n->children){
    j=(node)k->first;
    display_node(j);
  }
}
