typedef struct io_handler *io_handler;

struct io_handler{
  io_handler *last;
  io_handler next;
  int fd;
  int type;
  int (*function)();
  void *argument;
};

struct iovec *make_iov();


#define READ_HANDLER 1
#define WRITE_HANDLER 2
#define EXCEPTION_HANDLER 4
#define ALL_HANDLER (READ_HANDLER | WRITE_HANDLER | EXCEPTION_HANDLER)

io_handler register_io_handler();

#ifdef sun
#include <sys/filio.h>
#else
#include <sys/ioctl.h>
#endif

#ifdef _AIX
#include <sys/select.h>
#endif
