#include <anemone.h>

typdef struct xfig_space {
  char *filename;
  int fd;
} *xfig_space;

static void draw_line (space sp)
{
  xfig_space s=(xfig_space)sp->hardware_local;
  char *temp=string_format("2 1 0 1 -1 8 0 0 0.000 -1 0 0 %d %d %d 9999 9999",
			   x0,y0,x1,y1);
  write(s->fd,temp,strlen(temp));
  deallocate_memory(temp);
}

static void draw_node (space sp,node n)
{
  xfig_space s=(xfig_space)sp->hardware_local;
  printf ("1 2 0 1 -1 7 0 1 0.00000 1 0.000 %d %d",n->x,n->y);
        set x1 [lindex [.canv coords $i] 0]
        set y1 [lindex [.canv coords $i] 1]
        set x2 [lindex [.canv coords $i] 2]
        set y2 [lindex [.canv coords $i] 3]

        puts -nonewline [expr ($x2-$x1)/2]
        puts -nonewline " "
        puts -nonewline [expr ($y2-$y1)/2]
        puts -nonewline " "
        puts -nonewline $x1
        puts -nonewline " "
        puts -nonewline $cy
        puts -nonewline " "
        puts -nonewline $x1
        puts -nonewline " "
        puts $cy

     if {[.canv type $i] == "text"} { 
        printf ("4 1 18 16 0 -1 6 0.00000 4 ");
        set x [lindex [.canv coords $i] 0]
        set y [lindex [.canv coords $i] 1]
        puts -nonewline "15 80 "
	puts -nonewline $x
        puts -nonewline " "
	puts -nonewline $y
        puts -nonewline " "
        puts -nonewline [lindex [.canv itemconfigure $i -text] 4]
	puts "\001"
}

static void draw(space sp,int x0,int y0,int x1,int y1)
{
  char *temp=string_format("#FIG 2.1\n50 2\n");
}

space create_xfig_space(char *filename)
{
}
